"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var ej2_ng_diagrams_1 = require("@syncfusion/ej2-ng-diagrams");
var ej2_data_1 = require("@syncfusion/ej2-data");
ej2_ng_diagrams_1.Diagram.Inject(ej2_ng_diagrams_1.DataBinding, ej2_ng_diagrams_1.HierarchicalTree, ej2_ng_diagrams_1.LayoutAnimation);
/**
 * Default FlowShape sample
 */
var FlowDiagramComponent = (function () {
    function FlowDiagramComponent() {
        this.shapeType = { type: 'Basic', shape: 'Rectangle' };
        this.flowshapes = [
            { id: 'Terminator', shape: { type: 'Flow', shape: 'Terminator' } },
            { id: 'Process', shape: { type: 'Flow', shape: 'Process' } },
            { id: 'Decision', shape: { type: 'Flow', shape: 'Decision' } },
            { id: 'Document', shape: { type: 'Flow', shape: 'Document' } },
            { id: 'PreDefinedProcess', shape: { type: 'Flow', shape: 'PreDefinedProcess' } },
            { id: 'PaperTap', shape: { type: 'Flow', shape: 'PaperTap' } },
        ];
        this.imageShapes = [
            { id: 'Rectangle', shape: { type: 'Basic', shape: 'Rectangle' } },
            { id: 'Ellipse', shape: { type: 'Basic', shape: 'Ellipse' } },
            { id: 'Triangle', shape: { type: 'Basic', shape: 'Triangle' } },
            { id: 'Plus', shape: { type: 'Basic', shape: 'Plus' } },
            { id: 'Star', shape: { type: 'Basic', shape: 'Star' } },
            { id: 'Pentagon', shape: { type: 'Basic', shape: 'Pentagon' } },
        ];
        this.hierarchicalTree = [
            { Name: 'Diagram', fillColor: '#916DAF' },
            { Name: 'Layout', Category: 'Diagram' },
            { Name: 'Tree Layout', Category: 'Layout' },
            { Name: 'Organizational Chart', Category: 'Layout' },
            { Name: 'Hierarchical Tree', Category: 'Tree Layout' },
            { Name: 'Radial Tree', Category: 'Tree Layout' },
            { Name: 'Mind Map', Category: 'Hierarchical Tree' },
            { Name: 'Family Tree', Category: 'Hierarchical Tree' },
            { Name: 'Management', Category: 'Organizational Chart' },
            { Name: 'Human Resource', Category: 'Management' },
            { Name: 'University', Category: 'Management' },
            { Name: 'Business', Category: 'Management' }
        ];
        this.data = {
            // sets the fields to bind
            id: 'Name', parentId: 'Category',
            dataManager: new ej2_data_1.DataManager(this.hierarchicalTree),
            // binds the data with the nodes
            doBinding: function (nodeModel, data, diagram) {
                nodeModel.shape = { type: 'Text', content: data.Name };
            }
        };
        this.snapSettings = { constraints: ej2_ng_diagrams_1.SnapConstraints.All };
        this.layout = {
            type: 'HierarchicalTree', verticalSpacing: 30, horizontalSpacing: 40,
            enableAnimation: true
        };
        this.palettes = [
            {
                id: 'flow',
                expanded: true,
                symbols: this.flowshapes,
                iconCss: 'shapes',
                title: 'Flow Shapes'
            },
            {
                id: 'image',
                expanded: true,
                symbols: this.imageShapes,
                iconCss: 'shapes',
                title: 'Images'
            },
        ];
    }
    FlowDiagramComponent.prototype.nodeDefaults = function (obj) {
        obj.style = { fill: '#659be5', strokeColor: 'none', color: 'white', strokeWidth: 2 };
        obj.borderColor = '#3a6eb5';
        obj.backgroundColor = '#659be5';
        obj.shape.margin = { left: 5, right: 5, bottom: 5, top: 5 };
        obj.expandIcon = { height: 10, width: 10, shape: 'None', fill: 'lightgray', offset: { x: .5, y: 1 } };
        obj.expandIcon.verticalAlignment = 'Auto';
        obj.expandIcon.margin = { left: 0, right: 0, top: 0, bottom: 0 };
        obj.collapseIcon.offset = { x: .5, y: 1 };
        obj.collapseIcon.verticalAlignment = 'Auto';
        obj.collapseIcon.margin = { left: 0, right: 0, top: 0, bottom: 0 };
        obj.collapseIcon.height = 10;
        obj.collapseIcon.width = 10;
        obj.collapseIcon.padding.top = 5;
        obj.collapseIcon.shape = 'None';
        obj.collapseIcon.fill = 'lightgray';
        return obj;
    };
    ;
    FlowDiagramComponent.prototype.connDefaults = function (connector, diagram) {
        connector.targetDecorator.shape = 'None';
        connector.type = 'Orthogonal';
        connector.constraints = 0;
        connector.cornerRadius = 5;
        connector.style.strokeColor = '#6d6d6d';
        return connector;
    };
    ;
    FlowDiagramComponent.prototype.getSymbolInfo = function (symbol) {
        return { fit: true };
    };
    FlowDiagramComponent.prototype.getSymbolDefaults = function (symbol) {
        symbol.width = 50;
        symbol.height = 50;
    };
    return FlowDiagramComponent;
}());
__decorate([
    core_1.ViewChild('diagram'),
    __metadata("design:type", ej2_ng_diagrams_1.DiagramComponent)
], FlowDiagramComponent.prototype, "diagram", void 0);
FlowDiagramComponent = __decorate([
    core_1.Component({
        selector: 'main-section',
        templateUrl: 'app/diagram/diagram.component.html',
        encapsulation: core_1.ViewEncapsulation.None
    })
], FlowDiagramComponent);
exports.FlowDiagramComponent = FlowDiagramComponent;
//# sourceMappingURL=diagram.component.js.map