import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import {
  DiagramComponent, NodeModel, Diagram, SnapSettingsModel, SnapConstraints,
  DiagramContextMenu, HtmlModel, IExportOptions, ConnectorModel, NodeConstraints, GradientType, LinearGradientModel, RadialGradientModel, Rect, PageSettingsModel,
} from '@syncfusion/ej2-angular-diagrams';
import { ChangeEventArgs as CheckBoxChangeEventArgs } from '@syncfusion/ej2-buttons';
export interface EmployeeInfo {
  Name: string;
}
import { TemplateContent } from './button';
import { toPng, toBlob, toJpeg } from 'html-to-image';
import { saveAs } from 'file-saver';
import { NodeInfo } from './NodeInfo';
import { GradientColor } from '@syncfusion/ej2-base';
// import download = require('download');
Diagram.Inject(DiagramContextMenu);



/**
 * Default FlowShape sample
 */

@Component({
  selector: 'main-section',
  templateUrl: 'diagram.component.html',
  encapsulation: ViewEncapsulation.None
})
export class FlowDiagramComponent {
  @ViewChild('diagram') public diagram: DiagramComponent;
  public template: TemplateContent = new TemplateContent();
  public visibility: string = 'visible';
  // ngAfterViewInit(): void {
  //   let node: NodeModel = this.diagram.nodes[6];
  //   node.shape =  { type: 'HTML', content: this.template.content };
  //   this.diagram.dataBind();
  // }

  public nodeVisibleInfo: NodeInfo = { IsVisible: 'visible' };
  public nodeHiddenInfo: NodeInfo = { IsVisible: 'hidden' };

  public nodes: NodeModel[] = [
    // {
    //     id: 'HTML1', borderColor: 'black', borderWidth: 1, offsetX: 300, offsetY: 288, height: 100, width: 100,
    //     annotations: [ { content: 'Button'}],
    //     shape: {
    //         type: 'HTML',
    //         content: '<button type="button" style="width:100px"> Button</button>'
    //     }
    // },
    // {
    //     id: 'HTML2', borderColor: 'black', borderWidth: 1, offsetX: 150, offsetY: 250, height: 100, width: 100,
    //     annotations: [ { content: 'Button'}],
    //     shape: {
    //         type: 'HTML',
    //         content: '<button type="button" style="width:100px"> Button</button>'
    //     }
    // },
    // {
    //     id: 'HTML3', borderColor: 'black', borderWidth: 1, offsetX: 300, offsetY: 150, height: 100, width: 100,
    //     annotations: [ { content: 'Button'}],
    //     shape: {
    //         type: 'HTML',
    //         content: '<button type="button" style="width:100px"> Button</button>'
    //     }
    // },
    // {
    //     id: 'HTML4', borderColor: 'black', borderWidth: 1, offsetX: 450, offsetY: 250, height: 100, width: 100,
    //     annotations: [ { content: 'Button'}],
    //     shape: {
    //         type: 'HTML',
    //         content: '<button type="button" style="width:100px"> Button</button>'
    //     }
    // },
    {
      id: 'HTML5', borderColor: 'black', borderWidth: 1, offsetX: 100, offsetY: 100, height: 100, width: 100, addInfo: this.nodeHiddenInfo,
      annotations: [{ content: 'Button' }],
      shape: {
        type: 'HTML',
        content: '<div style="height:100%;width:100%;background-color:white"><img src="assets/Angular.png" width=100 height=100>Small Images is Hidden</img><div style="position: absolute;left: 80px;top:0px;visibility:${addInfo.IsVisible}"><img src="assets/sync.png" width=20 height=20/></div></div>'
      }
    },
    {
      id: 'HTML51', borderColor: 'black', borderWidth: 1, offsetX: 300, offsetY: 170, height: 100, width: 100, addInfo: this.nodeHiddenInfo,
      annotations: [{ content: 'Button' }],
      shape: {
        type: 'HTML',
        content: '<div style="height:100%;width:100%;background-color:white"><img src="assets/Angular.png" width=100 height=100>Small Images is Hidden</img><div style="position: absolute;left: 80px;top:0px;visibility:${addInfo.IsVisible}"><img src="assets/sync.png" width=20 height=20/></div></div>'
      }
    },
    {
      id: 'HTML6', borderColor: 'black', borderWidth: 1, offsetX: 300, offsetY: 400, height: 100, width: 100, addInfo: this.nodeVisibleInfo,
      annotations: [{ content: 'Button' }],
      shape: {
        type: 'HTML',
        content: '<div style="height:100%;width:100%;background-color:white"><img src="assets/Angular2.png" width=100 height=100>Small Images is Shown</img><div style="position: absolute;left: 80px;top:0px;visibility:${addInfo.IsVisible}"><img src="assets/sync.png" width=20 height=20/></div></div>'
      }
    },
    //  {
    //    id: 'HTML7', offsetX: 600, offsetY: 100, height: 100, width: 100, addInfo: { Test: 'Hai'},
    //    shape: {
    //        type: 'HTML',
    //        content: this.template.content
    //    }
    //},
  ];

  public connectors: ConnectorModel[] = [
    {
      id: "Con1",
      sourceID: "HTML5",
      targetID: "HTML6",
      type: "Orthogonal"
    }
  ]

  public snapSettings: SnapSettingsModel = {
    constraints: SnapConstraints.None
  };

  public pageSettings: PageSettingsModel = {
    background: { color: 'white'}
  };

  public showImageClick(args: Object) {
    console.log(this.nodeHiddenInfo.IsVisible);

    let template: string | HTMLElement;

    this.nodeHiddenInfo.IsVisible = 'visible';

    let nodes: NodeModel[] = this.diagram.nodes;

    for (let i = 0; i < nodes.length; i++) {
      template = (nodes[i].shape as HtmlModel).content;
      (nodes[i].shape as HtmlModel).content = '';
      (nodes[i].shape as HtmlModel).content = template;
    }
    this.diagram.dataBind();
    console.log(this.nodeHiddenInfo.IsVisible);
  }

  public hideImageClick(args: Object) {
    console.log(this.nodeHiddenInfo.IsVisible);

    this.nodeHiddenInfo.IsVisible = 'hidden';

    let template: string | HTMLElement;

    let nodes: NodeModel[] = this.diagram.nodes;

    for (let i = 0; i < nodes.length; i++) {
      template = (nodes[i].shape as HtmlModel).content;
      (nodes[i].shape as HtmlModel).content = '';
      (nodes[i].shape as HtmlModel).content = template;
    }

    this.diagram.dataBind();

    console.log(this.nodeHiddenInfo.IsVisible);
  }

  public exportDiagramClick(args: Object) {

    const htmlData: string = this.diagram.getDiagramContent();

    const div: HTMLElement = document.createElement('div');
    div.id = 'div';
    const rect = document.getElementById('diagram_backgroundLayerrect');
    const size = rect.getBoundingClientRect();
    div.style.height = String(size.height) + 'px';
    div.style.width = String(size.width) + 'px';
    div.innerHTML = htmlData;
    document.body.appendChild(div);

    // toJpeg(div, { quality: 0.95 })
    //   .then(function (dataUrl) {
    //     const link = document.createElement('a');
    //     link.download = 'my-image-name.jpeg';
    //     link.href = dataUrl;
    //     link.click();
    //     div.parentNode.removeChild(div);
    //   });

    toPng(div, { quality: 0.95 })
    .then(function (dataUrl) {
      const link = document.createElement('a');
      link.download = 'Diagram-html.png';
      link.href = dataUrl;
      link.click();
      div.parentNode.removeChild(div);
    });



    // let jsonResult = { htmlData: { htmlData: htmlData, width: size.width } };
  }

  public exportDiagramClick2(args: Object) {

    console.log('exportDiagramClick2');

    let exportOptions: IExportOptions = {};
    exportOptions.format = 'PNG';
    exportOptions.mode = 'Download';
    exportOptions.region = 'Content';
    exportOptions.multiplePage = true;
    exportOptions.fileName = 'Export';
    exportOptions.pageHeight = 800;
    exportOptions.pageWidth = 800;
    this.diagram.exportDiagram(exportOptions);
  }

  public nodeDefaults(obj: NodeModel): NodeModel {
    obj.style = { fill: '#37909A', strokeColor: '#024249' };
    if (obj.annotations.length) {
      obj.annotations[0].margin = { left: 10, right: 10 };
      obj.annotations[0].style = { color: 'white', fill: 'none', strokeColor: 'none' };
    }
    return obj;
  }

  public connDefaults(obj: ConnectorModel): void {
    obj.targetDecorator.style = { fill: '#024249', strokeColor: '#024249' };
    obj.style = { strokeColor: '#024249', strokeWidth: 2 };
  }





  public onChangeAspectRatio(args: CheckBoxChangeEventArgs): void {
    for (let i: number = 0; i < this.diagram.nodes.length; i++) {
      let node: NodeModel = this.diagram.nodes[i];
      let isShadowEnabled: number = node.constraints & NodeConstraints.Shadow;
      if (args.checked) {
        node.constraints =
          NodeConstraints.AspectRatio | NodeConstraints.Default;
      } else {
        node.constraints =
          NodeConstraints.Default & ~NodeConstraints.AspectRatio;
      }
      if (isShadowEnabled) {
        node.constraints |= NodeConstraints.Shadow;
      }
      this.diagram.dataBind();
    }
  }

  public onChangeLock(args: CheckBoxChangeEventArgs): void {
    for (let i: number = 0; i < this.diagram.nodes.length; i++) {
      let node: NodeModel = this.diagram.nodes[i];
      let isShadowEnabled: number = node.constraints & NodeConstraints.Shadow;
      if (args.checked) {
        node.constraints =
          NodeConstraints.PointerEvents | NodeConstraints.Select;
      } else {
        node.constraints = NodeConstraints.Default;
      }
      if (isShadowEnabled) {
        node.constraints |= NodeConstraints.Shadow;
      }
      this.diagram.dataBind();
    }
  }

  private documentClick(args: MouseEvent): void {
    let node: NodeModel;
    let target: HTMLElement = args.target as HTMLElement;
    let selectedElement: HTMLCollectionOf<Element> = document.getElementsByClassName('e-selected-style') as HTMLCollectionOf<Element>;
    if (selectedElement.length) {
      selectedElement[0].classList.remove('e-selected-style');
    }
    if (target.className === 'image-pattern-style') {
      for (let i: number = 0; i < this.diagram.nodes.length; i++) {
        node = this.diagram.nodes[i];
        switch (target.id) {
          case 'preview0':
            this.applyStyle(node, 0, undefined, ~NodeConstraints.Shadow, undefined);
            break;
          case 'preview1':
            this.applyStyle(node, 2, undefined, ~NodeConstraints.Shadow, undefined);
            break;
          case 'preview2':
            this.applyStyle(node, 2, '5,5', ~NodeConstraints.Shadow, undefined);
            break;
          case 'preview3':
            this.applyStyle(node, 2, '5,5', ~NodeConstraints.Shadow, 'Radial');
            break;
          case 'preview4':
            this.applyStyle(node, 2, '5,5', NodeConstraints.Shadow, undefined);
            break;
        }
        target.classList.add('e-selected-style');
      }
    }
  }

  private applyStyle(node: NodeModel, width: number, dashArray: string, con: NodeConstraints, type: GradientType): void {
    node.style.fill = '#37909A';
    node.style.strokeWidth = width;
    node.style.strokeColor = '#024249';
    node.style.strokeDashArray = dashArray;
    node.backgroundColor = '#024249';
    node.borderWidth = width;
    node.borderColor = 'red';
    node.constraints &= con;
    if (type === undefined) {
      node.style.gradient.type = 'None';
    } else {
      let gradient: GradientColor | LinearGradientModel | RadialGradientModel;
      gradient = {
        cx: 50, cy: 50, fx: 50, fy: 50,
        stops: [
          { color: '#00555b', offset: 0 },
          { color: '#37909A', offset: 90 }
        ],
        type: 'Radial'
      };
      node.style.gradient = gradient;
    }
    if (con & NodeConstraints.Shadow) {
      node.shadow = { angle: 45, distance: 15, opacity: 0.3, color: 'grey' };
      node.constraints |= con;
    }
    this.diagram.dataBind();

  }

}
